/**************************************************
howtosort.cpp
Wed 2/28/2007 6:42 pm creation
Mon 4/16/2007 6:51 pm discovered strcasecmp!
Tue 2/23/2010 10:19 am. Changed owenlabs address.

Reveals the hidden secret of the ages,
the uttermost hermetic gnostic truth:
how to do case-insensitive string sort
in C--.

Please note this code compiled successfully under
obsolete Borland Builder C++ version 5, and the
utterly update-to-date Macintosh X 10.4 g++!

j.g. owen * * * * * * * * * * * * * * * * * * *
web:   http://owenlabs.org/
email: owen_bda4@yahoo.com
* * * * * * * * * * * * * * * * * * * * * * * *

**************************************************/

#include <stdio.h>
#include <string>
#include <list>

using namespace std;

typedef list<string> JSTRINGLIST;

#if defined(__GNUC__) && (__GNUC__ >= 4)
  #define stricmp strcasecmp
#endif

int jstringicmp(const string &one, const string &two) {
  return stricmp(two.c_str(),one.c_str());
}

bool mysort(const string &a, const string &b) {
  return jstringicmp(a,b)>0;
}

bool myrevsort(const string &a, const string &b) {
  return jstringicmp(a,b)<=0;
}

int main(void) {

  JSTRINGLIST what;

  what.push_back("drive_crazed");
  what.push_back("hey");
  what.push_back("Hey");
  what.push_back("Babe");
  what.push_back("drive");
  what.push_back("Me");
  what.push_back("crazed");
  what.push_back("Drive_crazed");
  what.push_back("Drive");

  what.sort(mysort);

  JSTRINGLIST::iterator i;

  for (i=what.begin(); i!=what.end(); ++i) {
    printf("%s\n",i->c_str());
  }

  what.sort(myrevsort);
  printf("\nBackwards:\n\n");

  for (i=what.begin(); i!=what.end(); ++i) {
    printf("%s\n",i->c_str());
  }

  return 0;

}



